commit 53a122e48e7f0fe69c6283f7f1a3edbf4699e6f3
Author: Andreas Müller <a.mueller@bgbm.org>
Date:   Thu Oct 6 12:48:15 2016 +0200

    fix #6120 Cleanup uuidAndTitleCache methods

diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientAgentService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientAgentService.java
index c72fb04fa..d705cd56b 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientAgentService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientAgentService.java
@@ -861,5 +861,12 @@ public class TransientAgentService implements IAgentService {
 		return null;
 	}
 
+	@Override
+	public <S extends AgentBase> List<UuidAndTitleCache<S>> getUuidAndTitleCache(
+			Class<S> arg0, Integer arg1, String arg2) {
+		// TODO Auto-generated method stub
+		return null;
+	}
+
 
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientClassificationService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientClassificationService.java
index 643d78760..450425219 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientClassificationService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientClassificationService.java
@@ -1070,6 +1070,13 @@ public class TransientClassificationService implements IClassificationService {
 		return null;
 	}
 
+	@Override
+	public <S extends Classification> List<UuidAndTitleCache<S>> getUuidAndTitleCache(
+			Class<S> arg0, Integer arg1, String arg2) {
+		// TODO Auto-generated method stub
+		return null;
+	}
+
    
 
 
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientCollectionService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientCollectionService.java
index c06afc64d..5c823e58e 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientCollectionService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientCollectionService.java
@@ -768,6 +768,13 @@ public class TransientCollectionService implements ICollectionService {
 		return null;
 	}
 
+	@Override
+	public <S extends Collection> List<UuidAndTitleCache<S>> getUuidAndTitleCache(
+			Class<S> arg0, Integer arg1, String arg2) {
+		// TODO Auto-generated method stub
+		return null;
+	}
+
 
 
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientDescriptionService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientDescriptionService.java
index 5e1793c88..d7fc6be3d 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientDescriptionService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientDescriptionService.java
@@ -1253,5 +1253,12 @@ public class TransientDescriptionService implements IDescriptionService {
 		return null;
 	}
 
+	@Override
+	public <S extends DescriptionBase> List<UuidAndTitleCache<S>> getUuidAndTitleCache(
+			Class<S> arg0, Integer arg1, String arg2) {
+		// TODO Auto-generated method stub
+		return null;
+	}
+
 
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientNameService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientNameService.java
index 5bec09489..530a5b011 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientNameService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientNameService.java
@@ -1243,6 +1243,13 @@ public class TransientNameService implements INameService {
 		// TODO Auto-generated method stub
 		return null;
 	}
+
+	@Override
+	public <S extends TaxonNameBase> List<UuidAndTitleCache<S>> getUuidAndTitleCache(
+			Class<S> arg0, Integer arg1, String arg2) {
+		// TODO Auto-generated method stub
+		return null;
+	}
 	
 
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientOccurenceService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientOccurenceService.java
index dd6b392e0..82621f168 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientOccurenceService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientOccurenceService.java
@@ -1119,4 +1119,11 @@ public class TransientOccurenceService implements IOccurrenceService {
 		return null;
 	}
 
+	@Override
+	public <S extends SpecimenOrObservationBase> List<UuidAndTitleCache<S>> getUuidAndTitleCache(
+			Class<S> arg0, Integer arg1, String arg2) {
+		// TODO Auto-generated method stub
+		return null;
+	}
+
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientReferenceService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientReferenceService.java
index 68e522a7f..0f20cac20 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientReferenceService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientReferenceService.java
@@ -787,4 +787,11 @@ public class TransientReferenceService implements IReferenceService {
 		return null;
 	}
 
+	@Override
+	public <S extends Reference> List<UuidAndTitleCache<S>> getUuidAndTitleCache(
+			Class<S> arg0, Integer arg1, String arg2) {
+		// TODO Auto-generated method stub
+		return null;
+	}
+
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientTaxonService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientTaxonService.java
index 7dfd86d47..e3363d7ae 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientTaxonService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientTaxonService.java
@@ -1485,17 +1485,6 @@ public class TransientTaxonService implements ITaxonService {
 		return defaultService.getUuidAndTitleCache(limit, pattern);
 	}
 
-	@Override
-	public List<UuidAndTitleCache<TaxonBase>> getUuidAndTitleCacheTaxon(
-			Integer limit, String pattern) {
-		return defaultService.getUuidAndTitleCacheTaxon(limit, pattern);
-	}
-
-	@Override
-	public List<UuidAndTitleCache<TaxonBase>> getUuidAndTitleCacheSynonym(
-			Integer limit, String pattern) {
-		return defaultService.getUuidAndTitleCacheSynonym(limit, pattern);
-	}
 
 	@Override
 	public List<TaxonBase> loadByIds(List<Integer> idSet, List<String> propertyPaths) {
@@ -1518,5 +1507,12 @@ public class TransientTaxonService implements ITaxonService {
 		return null;
 	}
 
+	@Override
+	public <S extends TaxonBase> List<UuidAndTitleCache<S>> getUuidAndTitleCache(
+			Class<S> arg0, Integer arg1, String arg2) {
+		// TODO Auto-generated method stub
+		return null;
+	}
+
 
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientTermService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientTermService.java
index 87125d3a9..e1dc377c7 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientTermService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientTermService.java
@@ -933,4 +933,11 @@ public class TransientTermService implements ITermService {
 		// TODO Auto-generated method stub
 		return null;
 	}
+
+	@Override
+	public <S extends DefinedTermBase> List<UuidAndTitleCache<S>> getUuidAndTitleCache(
+			Class<S> arg0, Integer arg1, String arg2) {
+		// TODO Auto-generated method stub
+		return null;
+	}
 }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/dialog/selection/TaxonBaseSelectionDialog.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/dialog/selection/TaxonBaseSelectionDialog.java
index d28a01d24..4b0549593 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/dialog/selection/TaxonBaseSelectionDialog.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/dialog/selection/TaxonBaseSelectionDialog.java
@@ -10,6 +10,7 @@
 
 package eu.etaxonomy.taxeditor.ui.dialog.selection;
 
+import java.util.List;
 import java.util.UUID;
 
 import org.eclipse.swt.widgets.Control;
@@ -21,6 +22,7 @@ import eu.etaxonomy.cdm.api.service.ITaxonService;
 import eu.etaxonomy.cdm.model.taxon.Synonym;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.model.taxon.TaxonBase;
+import eu.etaxonomy.cdm.persistence.dto.UuidAndTitleCache;
 import eu.etaxonomy.taxeditor.newWizard.AbstractNewEntityWizard;
 import eu.etaxonomy.taxeditor.newWizard.NewTaxonWizard;
 import eu.etaxonomy.taxeditor.store.CdmStore;
@@ -69,7 +71,8 @@ public class TaxonBaseSelectionDialog extends AbstractFilteredCdmResourceSelecti
     }
 
     /** {@inheritDoc} */
-    @Override
+    @SuppressWarnings({ "unchecked", "rawtypes" })
+	@Override
     protected void initModel() {
         Control control = getPatternControl();
         String pattern = null;
@@ -79,15 +82,7 @@ public class TaxonBaseSelectionDialog extends AbstractFilteredCdmResourceSelecti
 
 
 
-        if(clazz == TaxonBase.class){
-            model = CdmStore.getService(ITaxonService.class).getUuidAndTitleCache(limitOfInitialElements, pattern);
-        }
-        else if(clazz == Taxon.class){
-            model = CdmStore.getService(ITaxonService.class).getUuidAndTitleCacheTaxon(limitOfInitialElements, pattern);
-        }
-        else if(clazz == Synonym.class){
-            model = CdmStore.getService(ITaxonService.class).getUuidAndTitleCacheSynonym(limitOfInitialElements, pattern);
-        }
+        model = (List)CdmStore.getService(ITaxonService.class).getUuidAndTitleCache(Taxon.class, limitOfInitialElements, pattern);
     }
 
     /** {@inheritDoc} */